<?php
/**
* The pagenumber-object
*
* Provides functionality for displaying pagenumbers
*
* @author	Eric Ross <eross1@chilesat.net>
* @author	Alexander Wirtz <alex@pc4p.net>
* @package	pc4p
* @version	$Id: pc4p_pagenumber.inc,v 1.6 2002/08/12 10:50:39 eru Exp $
*/
class pc4p_pagenumber extends pc4p_text
{
	/**
	* Predefine the text to display the pagenumber
	*
	* @var		array	$text
	* @access	private
	*/
	var $text = array( "%P" );

	/**
	* pc4p_pagenumber constructor
	*
	* Calls the constructor of pc4p_text
	*
	* @param	object	pc4p_page	&$parent	Parent of the pagenumber
	* @access	public
	* @see		pc4p_text::pc4p_text()
	* @author	Eric Ross <eross1@chilesat.net>
	* @author	Alexander Wirtz <alex@pc4p.net>
	*/
	function pc4p_pagenumber( &$parent )
	{
		pc4p_text::pc4p_text( $parent );
	}

	/**
	* Draw-function for pagenumbers
	*
	* Increments the pagenumber by one and then assigns the pagenumber as text to this object
	*
	* @access	public
	* @see		pc4p_text::pc4p_set_text(), pc4p_text::pc4p_draw()
	* @author	Eric Ross <eross1@chilesat.net>
	* @author	Alexander Wirtz <alex@pc4p.net>
	*/
	function pc4p_draw()
	{
		static $pagenumber = 0;
		$pagenumber++;

		pc4p_text::pc4p_set_text( strtr( implode( "\n", $this->text ), array( "%P" => $pagenumber ) ) );
		pc4p_text::pc4p_draw();

		unset( $this->pdfobj );
	}
}
?>
